SWCthunGlobalMeleeOverrideSave = {}
SWCthunGlobalCasterOverrideSave = {}
SWCthunGlobalHealerOverrideSave = {}

SWCthunGlobalHealerSortorderSave = {}
SWCthunGlobalCasterSortorderSave = {}
SWCthunGlobalMeleeSortorderSave = {}

local melee_sortorder = {}
local caster_sortorder = {}
local healer_sortorder = {}

local melee = {}
local caster = {}
local healer = {}

local dotPos = {
    [1] = {1, 102},
    [2] = {-34, 137},
    [3] = {-21, 178},  	--|Group 1
    [4] = {22, 178},
    [5] = {35, 137},

    [6] = {70, 74},
    [7] = {72, 123},
    [8] = {110, 142},   --|Group 2
    [9] = {140, 112},
    [10] = {120, 73},

    [11] = {-69, 72},
    [12] = {-118, 72},
    [13] = {-137, 110}, --|Group 3
    [14] = {-69, 121},
    [15] = {-107, 140},

    [16] = {100, 5},
    [17] = {136, 38},
    [18] = {176, 25},   --|Group 4
    [19] = {176, -18},
    [20] = {136, -31},

    [21] = {-97, 3},
    [22] = {-132, -33},
    [23] = {-173, -20}, --|Group 5
    [24] = {-173, 23},
    [25] = {-132, 36},

    [26] = {73, -67},
    [27] = {122, -67},
    [28] = {141, -104}, --|Group 6
    [29] = {111, -135},
    [30] = {73, -116},

    [31] = {-67, -68},
    [32] = {-67, -117},
    [33] = {-105, -136},--|Group 7
    [34] = {-136, -107},
    [35] = {-116, -68},
    
    [36] = {3, -97},
    [37] = {38, -131},
    [38] = {25, -172}, 	--|Group 8
    [39] = {-18, -172},
    [40] = {-32, -131}
}

local version = "v4" --Protocol version

local checkRoster = {}
local checkokRoster = {}
local checkofflineRoster = {}
local SWCthunPlanner_PlayerName, _ = UnitName("player")
local successfulRequest = C_ChatInfo.RegisterAddonMessagePrefix("SWCthunPlanner")
local firstFill = nil

-- options
local SWCthunOptions = {};
SWCthunOptions.panel = CreateFrame( "Frame", "SWCthunOptionsPanel", UIParent );
SWCthunOptions.panel.name = "SW C'Thun Planner";
InterfaceOptions_AddCategory(SWCthunOptions.panel);

SWCthunOptions.panel.title = SWCthunOptions.panel:CreateFontString(nil, "OVERLAY")
SWCthunOptions.panel.title:SetFontObject("GameFontHighlight");
SWCthunOptions.panel.title:SetPoint("TOP", SWCthunOptions.panel, 5, -15);
SWCthunOptions.panel.title:SetText("SW C'Thun Planner "..GetAddOnMetadata("SWCthunPlanner", "Version"))

SWCthunOptions.panel.roomprev = SWCthunOptions.panel:CreateTexture(nil, "BACKGROUND")
SWCthunOptions.panel.roomprev:SetPoint("TOPLEFT", SWCthunOptions.panel, 400, -45);
SWCthunOptions.panel.roomprev:SetTexture("Interface\\AddOns\\SWCthunPlanner\\Images\\CThun_Positioning.tga")
SWCthunOptions.panel.roomprev:SetSize(200, 200)

SWCthunOptions.panel.description = SWCthunOptions.panel:CreateFontString(nil, "OVERLAY")
SWCthunOptions.panel.description:SetFontObject("GameFontHighlight");
SWCthunOptions.panel.description:SetPoint("TOPLEFT", SWCthunOptions.panel, 5, -35);
SWCthunOptions.panel.description:SetJustifyH("LEFT")
SWCthunOptions.panel.description:SetJustifyV("TOP")
SWCthunOptions.panel.description:SetSize(390, 250)
SWCthunOptions.panel.description:SetText([[
|cffff0000usage:|r
|cff00d2d6/cthun |cff00ffffhelp|r|r -> shows all commands
|cff00d2d6/cthun|r -> shows and fills planner according to local overrides

|cffff0000for raidleaders:|r
|cff00d2d6/cthun |cff00ffffshare|r|r -> shares local override list with the raid, and shows addon window to all raid members

|cff00d2d6/cthun |cff00ffffmark|r|r -> Marks the frontmost melee in all groups with a raid target icon to make alignment by other group members easier

|cff00d2d6/cthun |cff00ffffcheck|r|r -> polls every raid member, if they have the addon installed, and lists all that do not have it installed (or have an old version)

|cff00d2d6/cthun |cff00ffffoptions|r|r -> shows this options screen
]])
SWCthunOptions.panel.description2 = SWCthunOptions.panel:CreateFontString(nil, "OVERLAY")
SWCthunOptions.panel.description2:SetFontObject("GameFontHighlight");
SWCthunOptions.panel.description2:SetPoint("TOPLEFT", SWCthunOptions.panel, 5, -265);
SWCthunOptions.panel.description2:SetJustifyH("LEFT")
SWCthunOptions.panel.description2:SetJustifyV("TOP")
SWCthunOptions.panel.description2:SetSize(600, 500)
SWCthunOptions.panel.description2:SetText([[
|cffff0000Info:|r
Melees are placed upfront close to C'Thun on the yellow dot. If more than one melee is in a group, the 2nd melee is placed in the 2nd row on the green dot.

Healers are placed on the white dot, when more than one healer are in a group, the 2nd healer is placed on one of the rear green dots.

Ranges are placed on the rearmost green dot.

Classes that can have multiple functions (e.g. Shamans) are not recognized autmagically. Shamans, Druids & Paladins are always assumed to be healers. Individual character names for these classes are defined in the "overrides" section of the config, to be classified as something other than a healer. (e.g. if you want a Drood to be classified as melee, put the character name in the Melee section)

All overrides only need to be defined by the raid leader who does -|cff00d2d6/cthun |cff00ffffshare|r|r-. Any locally defined overrides are ignored when a share is received.
]])


-- override panel
SWCthunOptions.overrides = CreateFrame( "Frame", "SWCthunOptionsPanel_overrides", SWCthunOptions.panel);
SWCthunOptions.overrides.name = "overrides";
SWCthunOptions.overrides.parent = SWCthunOptions.panel.name;
-- Add the child to the Interface Options

SWCthunOptions.overrides.groupnumbers = SWCthunOptions.overrides:CreateTexture(nil, "BACKGROUND")
SWCthunOptions.overrides.groupnumbers:SetPoint("TOPLEFT", SWCthunOptions.overrides, 330, -40);
SWCthunOptions.overrides.groupnumbers:SetTexture("Interface\\AddOns\\SWCthunPlanner\\Images\\CThun_groupnumbers.tga")
SWCthunOptions.overrides.groupnumbers:SetSize(70, 70)

SWCthunOptions.overrides.groupnumbers.description = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.groupnumbers.description:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.groupnumbers.description:SetText("The frontmost spot is #1\nthe white spot #2\n#3 #4 #5 follow\nin a clockwise fashion\nfor each group.")
SWCthunOptions.overrides.groupnumbers.description:SetJustifyH("LEFT")
SWCthunOptions.overrides.groupnumbers.description:SetJustifyV("TOP")
SWCthunOptions.overrides.groupnumbers.description:SetPoint("TOPLEFT", SWCthunOptions.overrides.groupnumbers, 75, 0);

SWCthunOptions.overrides.sortorder = CreateFrame( "Frame", "SWCthunOptionsPanel_overrides_sortorder", SWCthunOptions.overrides);
SWCthunOptions.overrides.sortorder:SetPoint("TOPLEFT", SWCthunOptions.overrides, 10, -10);
SWCthunOptions.overrides.sortorder:SetSize(500 ,500)

SWCthunOptions.overrides.sortorder:RegisterEvent("PLAYER_ENTERING_WORLD")
SWCthunOptions.overrides.sortorder:SetScript(
    "OnEvent",
    function(...)
        if #SWCthunGlobalMeleeSortorderSave == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Local melee ovverides empty, applying defaults", 1.0, 1.0, 0)
            SWCthunGlobalMeleeSortorderSave = {"1","5","3","2","4"}
        end
        if #SWCthunGlobalCasterSortorderSave == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Local caster ovverides empty, applying defaults", 1.0, 1.0, 0)
            SWCthunGlobalCasterSortorderSave = {"3","4","5","2","1"}
        end
        if #SWCthunGlobalHealerSortorderSave == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Local healer ovverides empty, applying defaults", 1.0, 1.0, 0)
            SWCthunGlobalHealerSortorderSave = {"2","4","3","5","1"}
        end
        local melee_sortordertext = " ";
        if next(SWCthunGlobalMeleeSortorderSave) ~= nil then
            for k, v in pairs(SWCthunGlobalMeleeSortorderSave) do
                melee_sortordertext = melee_sortordertext .. v .. " ";
            end
            SWCthunOptions.overrides.sortorder.melee1:Hide();
            SWCthunOptions.overrides.sortorder.melee2:Hide();
            SWCthunOptions.overrides.sortorder.melee3:Hide();
            SWCthunOptions.overrides.sortorder.melee4:Hide();
            SWCthunOptions.overrides.sortorder.melee5:Hide();
        end
        SWCthunOptions.overrides.sortorder.melee:SetText(melee_sortordertext)
        local caster_sortordertext = " ";
        if next(SWCthunGlobalCasterSortorderSave) ~= nil then
            for k, v in pairs(SWCthunGlobalCasterSortorderSave) do
                caster_sortordertext = caster_sortordertext .. v .. " ";
            end
            SWCthunOptions.overrides.sortorder.caster1:Hide();
            SWCthunOptions.overrides.sortorder.caster2:Hide();
            SWCthunOptions.overrides.sortorder.caster3:Hide();
            SWCthunOptions.overrides.sortorder.caster4:Hide();
            SWCthunOptions.overrides.sortorder.caster5:Hide();
        end
        SWCthunOptions.overrides.sortorder.caster:SetText(caster_sortordertext)
        local healer_sortordertext = " ";
        if next(SWCthunGlobalHealerSortorderSave) ~= nil then
            for k, v in pairs(SWCthunGlobalHealerSortorderSave) do
                healer_sortordertext = healer_sortordertext .. v .. " ";
            end
            SWCthunOptions.overrides.sortorder.healer1:Hide();
            SWCthunOptions.overrides.sortorder.healer2:Hide();
            SWCthunOptions.overrides.sortorder.healer3:Hide();
            SWCthunOptions.overrides.sortorder.healer4:Hide();
            SWCthunOptions.overrides.sortorder.healer5:Hide();
        end
        SWCthunOptions.overrides.sortorder.healer:SetText(healer_sortordertext)
    end
)

SWCthunOptions.overrides.sortorder.description = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.sortorder.description:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.sortorder.description:SetText("Define the sort order for each group slot. When slots are assigned, each player in a group is placed\nin the first free slot according to the roles' slot numbering. Clear to apply defaults.")
SWCthunOptions.overrides.sortorder.description:SetJustifyH("LEFT")
SWCthunOptions.overrides.sortorder.description:SetJustifyV("TOP")
SWCthunOptions.overrides.sortorder.description:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder, 0, 0);

-- MELEE

SWCthunOptions.overrides.sortorder.meleedesc = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.sortorder.meleedesc:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.sortorder.meleedesc:SetText("Melee")
SWCthunOptions.overrides.sortorder.meleedesc:SetJustifyH("LEFT")
SWCthunOptions.overrides.sortorder.meleedesc:SetJustifyV("TOP")
SWCthunOptions.overrides.sortorder.meleedesc:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder, 0, -35);

SWCthunOptions.overrides.sortorder.melee = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.sortorder.melee:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.sortorder.melee:SetJustifyH("LEFT")
SWCthunOptions.overrides.sortorder.melee:SetJustifyV("TOP")
SWCthunOptions.overrides.sortorder.melee:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.meleedesc, 50, 0);

SWCthunOptions.overrides.sortorder.meleeclear = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.meleeclear:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.melee, "TOPLEFT", 70, 8)
SWCthunOptions.overrides.sortorder.meleeclear:SetSize(50 ,25)
SWCthunOptions.overrides.sortorder.meleeclear:SetText("Clear")
SWCthunOptions.overrides.sortorder.meleeclear:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.meleeclear:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.melee:SetText(" ")
        SWCthunOptions.overrides.sortorder.melee1:Show();
        SWCthunOptions.overrides.sortorder.melee2:Show();
        SWCthunOptions.overrides.sortorder.melee3:Show();
        SWCthunOptions.overrides.sortorder.melee4:Show();
        SWCthunOptions.overrides.sortorder.melee5:Show();
    end
)

SWCthunOptions.overrides.sortorder.melee1 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.melee1:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.melee, "TOPLEFT", 125, 8)
SWCthunOptions.overrides.sortorder.melee1:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.melee1:SetText("1")
SWCthunOptions.overrides.sortorder.melee1:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.melee1:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.melee1:Hide()
        SWCthunOptions.overrides.sortorder.melee:SetText(SWCthunOptions.overrides.sortorder.melee:GetText() .. "1 ")
    end
)

SWCthunOptions.overrides.sortorder.melee2 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.melee2:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.melee, "TOPLEFT", 150, 8)
SWCthunOptions.overrides.sortorder.melee2:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.melee2:SetText("2")
SWCthunOptions.overrides.sortorder.melee2:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.melee2:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.melee2:Hide()
        SWCthunOptions.overrides.sortorder.melee:SetText(SWCthunOptions.overrides.sortorder.melee:GetText() .. "2 ")
    end
)

SWCthunOptions.overrides.sortorder.melee3 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.melee3:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.melee, "TOPLEFT", 175, 8)
SWCthunOptions.overrides.sortorder.melee3:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.melee3:SetText("3")
SWCthunOptions.overrides.sortorder.melee3:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.melee3:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.melee3:Hide()
        SWCthunOptions.overrides.sortorder.melee:SetText(SWCthunOptions.overrides.sortorder.melee:GetText() .. "3 ")
    end
)

SWCthunOptions.overrides.sortorder.melee4 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.melee4:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.melee, "TOPLEFT", 200, 8)
SWCthunOptions.overrides.sortorder.melee4:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.melee4:SetText("4")
SWCthunOptions.overrides.sortorder.melee4:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.melee4:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.melee4:Hide()
        SWCthunOptions.overrides.sortorder.melee:SetText(SWCthunOptions.overrides.sortorder.melee:GetText() .. "4 ")
    end
)

SWCthunOptions.overrides.sortorder.melee5 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.melee5:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.melee, "TOPLEFT", 225, 8)
SWCthunOptions.overrides.sortorder.melee5:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.melee5:SetText("5")
SWCthunOptions.overrides.sortorder.melee5:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.melee5:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.melee5:Hide()
        SWCthunOptions.overrides.sortorder.melee:SetText(SWCthunOptions.overrides.sortorder.melee:GetText() .. "5 ")
    end
)

-- CASTER

SWCthunOptions.overrides.sortorder.casterdesc = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.sortorder.casterdesc:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.sortorder.casterdesc:SetText("Caster")
SWCthunOptions.overrides.sortorder.casterdesc:SetJustifyH("LEFT")
SWCthunOptions.overrides.sortorder.casterdesc:SetJustifyV("TOP")
SWCthunOptions.overrides.sortorder.casterdesc:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder, 0, -60);

SWCthunOptions.overrides.sortorder.caster = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.sortorder.caster:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.sortorder.caster:SetJustifyH("LEFT")
SWCthunOptions.overrides.sortorder.caster:SetJustifyV("TOP")
SWCthunOptions.overrides.sortorder.caster:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.casterdesc, 50, 0);

SWCthunOptions.overrides.sortorder.casterclear = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.casterclear:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.caster, "TOPLEFT", 70, 8)
SWCthunOptions.overrides.sortorder.casterclear:SetSize(50 ,25)
SWCthunOptions.overrides.sortorder.casterclear:SetText("Clear")
SWCthunOptions.overrides.sortorder.casterclear:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.casterclear:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.caster:SetText(" ")
        SWCthunOptions.overrides.sortorder.caster1:Show();
        SWCthunOptions.overrides.sortorder.caster2:Show();
        SWCthunOptions.overrides.sortorder.caster3:Show();
        SWCthunOptions.overrides.sortorder.caster4:Show();
        SWCthunOptions.overrides.sortorder.caster5:Show();
    end
)

SWCthunOptions.overrides.sortorder.caster1 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.caster1:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.caster, "TOPLEFT", 125, 8)
SWCthunOptions.overrides.sortorder.caster1:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.caster1:SetText("1")
SWCthunOptions.overrides.sortorder.caster1:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.caster1:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.caster1:Hide()
        SWCthunOptions.overrides.sortorder.caster:SetText(SWCthunOptions.overrides.sortorder.caster:GetText() .. "1 ")
    end
)

SWCthunOptions.overrides.sortorder.caster2 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.caster2:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.caster, "TOPLEFT", 150, 8)
SWCthunOptions.overrides.sortorder.caster2:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.caster2:SetText("2")
SWCthunOptions.overrides.sortorder.caster2:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.caster2:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.caster2:Hide()
        SWCthunOptions.overrides.sortorder.caster:SetText(SWCthunOptions.overrides.sortorder.caster:GetText() .. "2 ")
    end
)

SWCthunOptions.overrides.sortorder.caster3 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.caster3:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.caster, "TOPLEFT", 175, 8)
SWCthunOptions.overrides.sortorder.caster3:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.caster3:SetText("3")
SWCthunOptions.overrides.sortorder.caster3:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.caster3:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.caster3:Hide()
        SWCthunOptions.overrides.sortorder.caster:SetText(SWCthunOptions.overrides.sortorder.caster:GetText() .. "3 ")
    end
)

SWCthunOptions.overrides.sortorder.caster4 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.caster4:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.caster, "TOPLEFT", 200, 8)
SWCthunOptions.overrides.sortorder.caster4:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.caster4:SetText("4")
SWCthunOptions.overrides.sortorder.caster4:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.caster4:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.caster4:Hide()
        SWCthunOptions.overrides.sortorder.caster:SetText(SWCthunOptions.overrides.sortorder.caster:GetText() .. "4 ")
    end
)

SWCthunOptions.overrides.sortorder.caster5 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.caster5:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.caster, "TOPLEFT", 225, 8)
SWCthunOptions.overrides.sortorder.caster5:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.caster5:SetText("5")
SWCthunOptions.overrides.sortorder.caster5:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.caster5:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.caster5:Hide()
        SWCthunOptions.overrides.sortorder.caster:SetText(SWCthunOptions.overrides.sortorder.caster:GetText() .. "5 ")
    end
)

-- HEALER

SWCthunOptions.overrides.sortorder.healerdesc = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.sortorder.healerdesc:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.sortorder.healerdesc:SetText("Healer")
SWCthunOptions.overrides.sortorder.healerdesc:SetJustifyH("LEFT")
SWCthunOptions.overrides.sortorder.healerdesc:SetJustifyV("TOP")
SWCthunOptions.overrides.sortorder.healerdesc:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder, 0, -85);

SWCthunOptions.overrides.sortorder.healer = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.sortorder.healer:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.sortorder.healer:SetJustifyH("LEFT")
SWCthunOptions.overrides.sortorder.healer:SetJustifyV("TOP")
SWCthunOptions.overrides.sortorder.healer:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.healerdesc, 50, 0);

SWCthunOptions.overrides.sortorder.healerclear = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.healerclear:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.healer, "TOPLEFT", 70, 8)
SWCthunOptions.overrides.sortorder.healerclear:SetSize(50 ,25)
SWCthunOptions.overrides.sortorder.healerclear:SetText("Clear")
SWCthunOptions.overrides.sortorder.healerclear:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.healerclear:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.healer:SetText(" ")
        SWCthunOptions.overrides.sortorder.healer1:Show();
        SWCthunOptions.overrides.sortorder.healer2:Show();
        SWCthunOptions.overrides.sortorder.healer3:Show();
        SWCthunOptions.overrides.sortorder.healer4:Show();
        SWCthunOptions.overrides.sortorder.healer5:Show();
    end
)

SWCthunOptions.overrides.sortorder.healer1 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.healer1:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.healer, "TOPLEFT", 125, 8)
SWCthunOptions.overrides.sortorder.healer1:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.healer1:SetText("1")
SWCthunOptions.overrides.sortorder.healer1:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.healer1:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.healer1:Hide()
        SWCthunOptions.overrides.sortorder.healer:SetText(SWCthunOptions.overrides.sortorder.healer:GetText() .. "1 ")
    end
)

SWCthunOptions.overrides.sortorder.healer2 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.healer2:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.healer, "TOPLEFT", 150, 8)
SWCthunOptions.overrides.sortorder.healer2:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.healer2:SetText("2")
SWCthunOptions.overrides.sortorder.healer2:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.healer2:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.healer2:Hide()
        SWCthunOptions.overrides.sortorder.healer:SetText(SWCthunOptions.overrides.sortorder.healer:GetText() .. "2 ")
    end
)

SWCthunOptions.overrides.sortorder.healer3 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.healer3:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.healer, "TOPLEFT", 175, 8)
SWCthunOptions.overrides.sortorder.healer3:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.healer3:SetText("3")
SWCthunOptions.overrides.sortorder.healer3:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.healer3:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.healer3:Hide()
        SWCthunOptions.overrides.sortorder.healer:SetText(SWCthunOptions.overrides.sortorder.healer:GetText() .. "3 ")
    end
)

SWCthunOptions.overrides.sortorder.healer4 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.healer4:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.healer, "TOPLEFT", 200, 8)
SWCthunOptions.overrides.sortorder.healer4:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.healer4:SetText("4")
SWCthunOptions.overrides.sortorder.healer4:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.healer4:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.healer4:Hide()
        SWCthunOptions.overrides.sortorder.healer:SetText(SWCthunOptions.overrides.sortorder.healer:GetText() .. "4 ")
    end
)

SWCthunOptions.overrides.sortorder.healer5 = CreateFrame("Button", "__b", SWCthunOptions.overrides.sortorder, "UIPanelButtonTemplate")
SWCthunOptions.overrides.sortorder.healer5:SetPoint("TOPLEFT", SWCthunOptions.overrides.sortorder.healer, "TOPLEFT", 225, 8)
SWCthunOptions.overrides.sortorder.healer5:SetSize(25 ,25)
SWCthunOptions.overrides.sortorder.healer5:SetText("5")
SWCthunOptions.overrides.sortorder.healer5:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
SWCthunOptions.overrides.sortorder.healer5:SetScript(
    "OnClick",
    function()
        SWCthunOptions.overrides.sortorder.healer5:Hide()
        SWCthunOptions.overrides.sortorder.healer:SetText(SWCthunOptions.overrides.sortorder.healer:GetText() .. "5 ")
    end
)

-- OVERRIDELISTS

SWCthunOptions.overrides.overridesdescription = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.overridesdescription:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.overridesdescription:SetText("Overrides: One name per line! Exact naming, including custom characters and capitalization.")
SWCthunOptions.overrides.overridesdescription:SetJustifyH("LEFT")
SWCthunOptions.overrides.overridesdescription:SetJustifyV("TOP")
SWCthunOptions.overrides.overridesdescription:SetPoint("TOPLEFT", SWCthunOptions.overrides, 10, -120);

SWCthunOptions.overrides.meleebox = CreateFrame("Frame", "SWCthunOptionsPanel_overrides_melee", SWCthunOptions.overrides)
SWCthunOptions.overrides.meleebox:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = 2, right = 2, top = 2, bottom = 2},
})
SWCthunOptions.overrides.meleebox:SetBackdropColor(0, 0, 0, 0.3)
SWCthunOptions.overrides.meleebox:SetBackdropBorderColor(0.3, 0.3, 0.3)
SWCthunOptions.overrides.meleebox:SetSize(200, 400)
SWCthunOptions.overrides.meleebox.text = CreateFrame("EditBox", "SWCthunOptionsPanel_overrides_meleetext", SWCthunOptions.overrides.meleebox, menu)
SWCthunOptions.overrides.meleebox.text:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = -2, right = -2, top = -2, bottom = -2},
})
SWCthunOptions.overrides.meleebox.text:SetBackdropColor(1, 1, 1, 0.2)
SWCthunOptions.overrides.meleebox.text:SetMultiLine(true)
SWCthunOptions.overrides.meleebox.text:SetSize(190, 400)
SWCthunOptions.overrides.meleebox.text:SetAutoFocus(false)
SWCthunOptions.overrides.meleebox.text:SetFontObject("GameFontNormalSmall")
SWCthunOptions.overrides.meleebox.text:SetCursorPosition(0)
SWCthunOptions.overrides.meleebox.text:RegisterEvent("PLAYER_ENTERING_WORLD")
SWCthunOptions.overrides.meleebox.text:SetScript(
        "OnEvent",
    function(...)
        SWCthunOptions.overrides.meleebox.text:SetText("")
        for index, value in ipairs(SWCthunGlobalMeleeOverrideSave) do
            SWCthunOptions.overrides.meleebox.text:Insert(value.."\n")
        end
    end
)
SWCthunOptions.overrides.meleebox.text:SetPoint("TOPLEFT", SWCthunOptions.overrides.meleebox, "TOPLEFT", 5, -5)


SWCthunOptions.overrides.casterbox = CreateFrame("Frame", "SWCthunOptionsPanel_overrides_caster", SWCthunOptions.overrides)
SWCthunOptions.overrides.casterbox:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = 2, right = 2, top = 2, bottom = 2},
})
SWCthunOptions.overrides.casterbox:SetBackdropColor(0, 0, 0, 0.3)
SWCthunOptions.overrides.casterbox:SetBackdropBorderColor(0.3, 0.3, 0.3)
SWCthunOptions.overrides.casterbox:SetSize(200, 400)
SWCthunOptions.overrides.casterbox.text = CreateFrame("EditBox", "SWCthunOptionsPanel_overrides_castertext", SWCthunOptions.overrides.casterbox, menu)
SWCthunOptions.overrides.casterbox.text:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = -2, right = -2, top = -2, bottom = -2},
})
SWCthunOptions.overrides.casterbox.text:SetBackdropColor(1, 1, 1, 0.2)
SWCthunOptions.overrides.casterbox.text:SetMultiLine(true)
SWCthunOptions.overrides.casterbox.text:SetSize(190, 400)
SWCthunOptions.overrides.casterbox.text:SetAutoFocus(false)
SWCthunOptions.overrides.casterbox.text:SetFontObject("GameFontNormalSmall")
SWCthunOptions.overrides.casterbox.text:SetCursorPosition(0)
SWCthunOptions.overrides.casterbox.text:RegisterEvent("PLAYER_ENTERING_WORLD")
SWCthunOptions.overrides.casterbox.text:SetScript(
        "OnEvent",
    function(...)
        SWCthunOptions.overrides.casterbox.text:SetText("")
        for index, value in ipairs(SWCthunGlobalCasterOverrideSave) do
            SWCthunOptions.overrides.casterbox.text:Insert(value.."\n")
        end
    end
)
SWCthunOptions.overrides.casterbox.text:SetPoint("TOPLEFT", SWCthunOptions.overrides.casterbox, "TOPLEFT", 5, -5)

SWCthunOptions.overrides.healerbox = CreateFrame("Frame", "SWCthunOptionsPanel_overrides_healer", SWCthunOptions.overrides)
SWCthunOptions.overrides.healerbox:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = 2, right = 2, top = 2, bottom = 2},
})
SWCthunOptions.overrides.healerbox:SetBackdropColor(0, 0, 0, 0.3)
SWCthunOptions.overrides.healerbox:SetBackdropBorderColor(0.3, 0.3, 0.3)
SWCthunOptions.overrides.healerbox:SetSize(200, 400)
SWCthunOptions.overrides.healerbox.text = CreateFrame("EditBox", "SWCthunOptionsPanel_overrides_healertext", SWCthunOptions.overrides.healerbox, menu)
SWCthunOptions.overrides.healerbox.text:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = -2, right = -2, top = -2, bottom = -2},
})
SWCthunOptions.overrides.healerbox.text:SetBackdropColor(1, 1, 1, 0.2)
SWCthunOptions.overrides.healerbox.text:SetMultiLine(true)
SWCthunOptions.overrides.healerbox.text:SetSize(190, 400)
SWCthunOptions.overrides.healerbox.text:SetAutoFocus(false)
SWCthunOptions.overrides.healerbox.text:SetFontObject("GameFontNormalSmall")
SWCthunOptions.overrides.healerbox.text:SetCursorPosition(0)
SWCthunOptions.overrides.healerbox.text:RegisterEvent("PLAYER_ENTERING_WORLD")
SWCthunOptions.overrides.healerbox.text:SetScript(
        "OnEvent",
    function(...)
        SWCthunOptions.overrides.healerbox.text:SetText("")
        for index, value in ipairs(SWCthunGlobalHealerOverrideSave) do
            SWCthunOptions.overrides.healerbox.text:Insert(value.."\n")
        end
    end
)
SWCthunOptions.overrides.healerbox.text:SetPoint("TOPLEFT", SWCthunOptions.overrides.healerbox, "TOPLEFT", 5, -5)

SWCthunOptions.overrides.healerbox.title = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.healerbox.title:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.healerbox.title:SetPoint("TOPLEFT", SWCthunOptions.overrides.healerbox, 5, 15);
SWCthunOptions.overrides.healerbox.title:SetText("Healers")

SWCthunOptions.overrides.casterbox.title = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.casterbox.title:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.casterbox.title:SetPoint("TOPLEFT", SWCthunOptions.overrides.casterbox, 5, 15);
SWCthunOptions.overrides.casterbox.title:SetText("Casters")

SWCthunOptions.overrides.meleebox.title = SWCthunOptions.overrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.overrides.meleebox.title:SetFontObject("GameFontHighlight");
SWCthunOptions.overrides.meleebox.title:SetPoint("TOPLEFT", SWCthunOptions.overrides.meleebox, 5, 15);
SWCthunOptions.overrides.meleebox.title:SetText("Melee")

SWCthunOptions.overrides.meleebox:SetPoint("TOPLEFT", SWCthunOptions.overrides, "TOPLEFT", 5, -150)
SWCthunOptions.overrides.casterbox:SetPoint("TOPLEFT", SWCthunOptions.overrides, "TOPLEFT", 210, -150)
SWCthunOptions.overrides.healerbox:SetPoint("TOPLEFT", SWCthunOptions.overrides, "TOPLEFT", 415, -150)

--	-- [[ When the player clicks okay, set the original value to the current setting ]] --
    SWCthunOptions.overrides.okay = 
        function (self)
            SWCthunGlobalMeleeOverrideSave = {}
            local myTable = splitstring(SWCthunOptions.overrides.meleebox.text:GetText(),"\n")
            for index, value in ipairs(myTable) do
                table.insert(SWCthunGlobalMeleeOverrideSave,value)
            end

            SWCthunGlobalCasterOverrideSave = {}
            local myTable = splitstring(SWCthunOptions.overrides.casterbox.text:GetText(),"\n")
            for index, value in ipairs(myTable) do
                table.insert(SWCthunGlobalCasterOverrideSave,value)
            end

            SWCthunGlobalHealerOverrideSave = {}
            local myTable = splitstring(SWCthunOptions.overrides.healerbox.text:GetText(),"\n")
            for index, value in ipairs(myTable) do
                table.insert(SWCthunGlobalHealerOverrideSave,value)
            end

            SWCthunGlobalMeleeSortorderSave = {}
            local myTable = splitstring(trim(SWCthunOptions.overrides.sortorder.melee:GetText())," ")
            for index, value in ipairs(myTable) do
                table.insert(SWCthunGlobalMeleeSortorderSave,value)
            end
            if #SWCthunGlobalMeleeSortorderSave < 5 then
                DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Local melee ovverides incomplete, applying defaults", 1.0, 1.0, 0)
                SWCthunGlobalMeleeSortorderSave = {"1","5","3","2","4"}
            end

            SWCthunGlobalCasterSortorderSave = {}
            local myTable = splitstring(trim(SWCthunOptions.overrides.sortorder.caster:GetText())," ")
            for index, value in ipairs(myTable) do
                table.insert(SWCthunGlobalCasterSortorderSave,value)
            end
            if #SWCthunGlobalCasterSortorderSave < 5 then
                DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Local caster ovverides incomplete, applying defaults", 1.0, 1.0, 0)
                SWCthunGlobalCasterSortorderSave = {"3","4","5","2","1"}
            end

            SWCthunGlobalHealerSortorderSave = {}
            local myTable = splitstring(trim(SWCthunOptions.overrides.sortorder.healer:GetText())," ")
            for index, value in ipairs(myTable) do
                table.insert(SWCthunGlobalHealerSortorderSave,value)
            end
            if #SWCthunGlobalHealerSortorderSave < 5 then
                DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Local healer ovverides incomplete, applying defaults", 1.0, 1.0, 0)
                SWCthunGlobalHealerSortorderSave = {"2","4","3","5","1"}
            end

            local melee_sortordertext = " ";
            if next(SWCthunGlobalMeleeSortorderSave) ~= nil then
                for k, v in pairs(SWCthunGlobalMeleeSortorderSave) do
                    melee_sortordertext = melee_sortordertext .. v .. " ";
                end
                SWCthunOptions.overrides.sortorder.melee1:Hide();
                SWCthunOptions.overrides.sortorder.melee2:Hide();
                SWCthunOptions.overrides.sortorder.melee3:Hide();
                SWCthunOptions.overrides.sortorder.melee4:Hide();
                SWCthunOptions.overrides.sortorder.melee5:Hide();
            end
            SWCthunOptions.overrides.sortorder.melee:SetText(melee_sortordertext)
            local caster_sortordertext = " ";
            if next(SWCthunGlobalCasterSortorderSave) ~= nil then
                for k, v in pairs(SWCthunGlobalCasterSortorderSave) do
                    caster_sortordertext = caster_sortordertext .. v .. " ";
                end
                SWCthunOptions.overrides.sortorder.caster1:Hide();
                SWCthunOptions.overrides.sortorder.caster2:Hide();
                SWCthunOptions.overrides.sortorder.caster3:Hide();
                SWCthunOptions.overrides.sortorder.caster4:Hide();
                SWCthunOptions.overrides.sortorder.caster5:Hide();
            end
            SWCthunOptions.overrides.sortorder.caster:SetText(caster_sortordertext)
            local healer_sortordertext = " ";
            if next(SWCthunGlobalHealerSortorderSave) ~= nil then
                for k, v in pairs(SWCthunGlobalHealerSortorderSave) do
                    healer_sortordertext = healer_sortordertext .. v .. " ";
                end
                SWCthunOptions.overrides.sortorder.healer1:Hide();
                SWCthunOptions.overrides.sortorder.healer2:Hide();
                SWCthunOptions.overrides.sortorder.healer3:Hide();
                SWCthunOptions.overrides.sortorder.healer4:Hide();
                SWCthunOptions.overrides.sortorder.healer5:Hide();
            end
            SWCthunOptions.overrides.sortorder.healer:SetText(healer_sortordertext)


            DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Local overrides saved...", 1.0, 1.0, 0)
        end
--
--	-- [[ When the player clicks cancel, set the current setting to the original value ]] --
    SWCthunOptions.overrides.cancel =
		function (self)
			debug("cancel");
		end
InterfaceOptions_AddCategory(SWCthunOptions.overrides);

------------------------------------------------------------------------
-- Raidoverrides
------------------------------------------------------------------------

SWCthunOptions.raidoverrides = CreateFrame( "Frame", "SWCthunOptionsPanel_raidoverrides", SWCthunOptions.panel);
SWCthunOptions.raidoverrides.name = "from raid";
SWCthunOptions.raidoverrides.parent = SWCthunOptions.panel.name;

SWCthunOptions.raidoverrides.sortorder = CreateFrame( "Frame", "SWCthunOptionsPanel_raidoverrides_sortorder", SWCthunOptions.overrides);
SWCthunOptions.raidoverrides.sortorder:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides, 10, -10);
SWCthunOptions.raidoverrides.sortorder:SetSize(500 ,500)

SWCthunOptions.raidoverrides.sortorder.description = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.sortorder.description:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.sortorder.description:SetText("Sort order received from Raid leader. When slots are assigned, each player in a group is placed\nin the first free slot according to the roles' slot numbering")
SWCthunOptions.raidoverrides.sortorder.description:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.sortorder.description:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.sortorder.description:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.sortorder, 0, 0);

-- MELEE

SWCthunOptions.raidoverrides.sortorder.meleedesc = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.sortorder.meleedesc:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.sortorder.meleedesc:SetText("Melee")
SWCthunOptions.raidoverrides.sortorder.meleedesc:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.sortorder.meleedesc:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.sortorder.meleedesc:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.sortorder, 0, -35);

SWCthunOptions.raidoverrides.sortorder.melee = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.sortorder.melee:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.sortorder.melee:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.sortorder.melee:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.sortorder.melee:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.sortorder.meleedesc, 50, 0);

-- CASTER

SWCthunOptions.raidoverrides.sortorder.casterdesc = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.sortorder.casterdesc:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.sortorder.casterdesc:SetText("Caster")
SWCthunOptions.raidoverrides.sortorder.casterdesc:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.sortorder.casterdesc:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.sortorder.casterdesc:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.sortorder, 0, -60);

SWCthunOptions.raidoverrides.sortorder.caster = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.sortorder.caster:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.sortorder.caster:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.sortorder.caster:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.sortorder.caster:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.sortorder.casterdesc, 50, 0);

-- HEALER

SWCthunOptions.raidoverrides.sortorder.healerdesc = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.sortorder.healerdesc:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.sortorder.healerdesc:SetText("Healer")
SWCthunOptions.raidoverrides.sortorder.healerdesc:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.sortorder.healerdesc:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.sortorder.healerdesc:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.sortorder, 0, -85);

SWCthunOptions.raidoverrides.sortorder.healer = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.sortorder.healer:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.sortorder.healer:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.sortorder.healer:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.sortorder.healer:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.sortorder.healerdesc, 50, 0);

-- Overrides

SWCthunOptions.raidoverrides.overridesdescription = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.overridesdescription:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.overridesdescription:SetText("Last overrides received by share...")
SWCthunOptions.raidoverrides.overridesdescription:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides, 10, -120);

SWCthunOptions.raidoverrides.meleebox = CreateFrame("Frame", "SWCthunOptionsPanel_raidoverrides_melee", SWCthunOptions.raidoverrides)
SWCthunOptions.raidoverrides.meleebox:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = 2, right = 2, top = 2, bottom = 2},
})
SWCthunOptions.raidoverrides.meleebox:SetBackdropColor(0, 0, 0, 0.3)
SWCthunOptions.raidoverrides.meleebox:SetBackdropBorderColor(0.3, 0.3, 0.3)
SWCthunOptions.raidoverrides.meleebox:SetSize(200, 400)
SWCthunOptions.raidoverrides.meleebox.text = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.meleebox.text:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.meleebox.text:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.meleebox.text:SetSize(190, 400)
SWCthunOptions.raidoverrides.meleebox.text:SetFontObject("GameFontNormalSmall")
SWCthunOptions.raidoverrides.meleebox:RegisterEvent("PLAYER_ENTERING_WORLD")
SWCthunOptions.raidoverrides.meleebox:SetScript(
        "OnEvent",
    function(...)
        local text = ""
        for index, value in ipairs(melee) do
            text = text .. value .. "\n"
        end
        SWCthunOptions.raidoverrides.meleebox.text:SetText(text)
    end
)
SWCthunOptions.raidoverrides.meleebox.text:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.meleebox, "TOPLEFT", 5, -5)


SWCthunOptions.raidoverrides.casterbox = CreateFrame("Frame", "SWCthunOptionsPanel_raidoverrides_caster", SWCthunOptions.raidoverrides)
SWCthunOptions.raidoverrides.casterbox:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = 2, right = 2, top = 2, bottom = 2},
})
SWCthunOptions.raidoverrides.casterbox:SetBackdropColor(0, 0, 0, 0.3)
SWCthunOptions.raidoverrides.casterbox:SetBackdropBorderColor(0.3, 0.3, 0.3)
SWCthunOptions.raidoverrides.casterbox:SetSize(200, 400)
SWCthunOptions.raidoverrides.casterbox.text = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.casterbox.text:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.casterbox.text:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.casterbox.text:SetSize(190, 400)
SWCthunOptions.raidoverrides.casterbox.text:SetFontObject("GameFontNormalSmall")
SWCthunOptions.raidoverrides.casterbox:RegisterEvent("PLAYER_ENTERING_WORLD")
SWCthunOptions.raidoverrides.casterbox:SetScript(
        "OnEvent",
    function(...)
        local text = ""
        for index, value in ipairs(caster) do
            text = text .. value .. "\n"
        end
        SWCthunOptions.raidoverrides.casterbox.text:SetText(text)
    end
)
SWCthunOptions.raidoverrides.casterbox.text:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.casterbox, "TOPLEFT", 5, -5)

SWCthunOptions.raidoverrides.healerbox = CreateFrame("Frame", "SWCthunOptionsPanel_raidoverrides_healer", SWCthunOptions.raidoverrides)
SWCthunOptions.raidoverrides.healerbox:SetBackdrop({
	bgFile = [[Interface\Buttons\WHITE8x8]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	edgeSize = 2,
	insets = {left = 2, right = 2, top = 2, bottom = 2},
})
SWCthunOptions.raidoverrides.healerbox:SetBackdropColor(0, 0, 0, 0.3)
SWCthunOptions.raidoverrides.healerbox:SetBackdropBorderColor(0.3, 0.3, 0.3)
SWCthunOptions.raidoverrides.healerbox:SetSize(200, 400)
SWCthunOptions.raidoverrides.healerbox.text = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.healerbox.text:SetJustifyH("LEFT")
SWCthunOptions.raidoverrides.healerbox.text:SetJustifyV("TOP")
SWCthunOptions.raidoverrides.healerbox.text:SetSize(190, 400)
SWCthunOptions.raidoverrides.healerbox.text:SetFontObject("GameFontNormalSmall")
SWCthunOptions.raidoverrides.healerbox:RegisterEvent("PLAYER_ENTERING_WORLD")
SWCthunOptions.raidoverrides.healerbox:SetScript(
        "OnEvent",
        function(...)
            local text = ""
            for index, value in ipairs(healer) do
                text = text .. value .. "\n"
            end
            SWCthunOptions.raidoverrides.healerbox.text:SetText(text)
        end
)
SWCthunOptions.raidoverrides.healerbox.text:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.healerbox, "TOPLEFT", 5, -5)

SWCthunOptions.raidoverrides.healerbox.title = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.healerbox.title:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.healerbox.title:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.healerbox, 5, 15);
SWCthunOptions.raidoverrides.healerbox.title:SetText("Healers")

SWCthunOptions.raidoverrides.casterbox.title = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.casterbox.title:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.casterbox.title:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.casterbox, 5, 15);
SWCthunOptions.raidoverrides.casterbox.title:SetText("Casters")

SWCthunOptions.raidoverrides.meleebox.title = SWCthunOptions.raidoverrides:CreateFontString(nil, "OVERLAY")
SWCthunOptions.raidoverrides.meleebox.title:SetFontObject("GameFontHighlight");
SWCthunOptions.raidoverrides.meleebox.title:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides.meleebox, 5, 15);
SWCthunOptions.raidoverrides.meleebox.title:SetText("Melee")

SWCthunOptions.raidoverrides.meleebox:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides, "TOPLEFT", 5, -150)
SWCthunOptions.raidoverrides.casterbox:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides, "TOPLEFT", 210, -150)
SWCthunOptions.raidoverrides.healerbox:SetPoint("TOPLEFT", SWCthunOptions.raidoverrides, "TOPLEFT", 415, -150)

InterfaceOptions_AddCategory(SWCthunOptions.raidoverrides);


if not successfulRequest then
    DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Error creating addon channel.", 1.0, 1.0, 0)
end

local cthunbackdrop = {
    bgFile = "Interface\\AddOns\\SWCthunPlanner\\Images\\CThun_Positioning.tga",
    edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
    tile = false,
    edgeSize = 16,
    insets = {
        left = 0,
        right = 0,
        top = 0,
        bottom = 0
    }
}

local frame = CreateFrame("Frame", "Cthun_room", UIParent)
frame:EnableMouse(true)
frame:SetMovable(true)
frame:SetResizable(true)
frame:SetFrameStrata("FULLSCREEN")
frame:SetHeight(534)
frame:SetWidth(534)
frame:SetScale(1)
frame:SetPoint("CENTER", 0, 0)
frame:SetBackdrop(cthunbackdrop)
frame:SetAlpha(1.00)
frame.x = frame:GetLeft()
frame.y = (frame:GetTop() - frame:GetHeight())
frame:Hide()

frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("CHAT_MSG_ADDON")
frame:SetScript(
    "OnEvent",
    function(...)
        local _, event, prefix, msg, dist, sender = ...
        local playername = UnitName("player")
        if event == "PLAYER_ENTERING_WORLD" then
            _, _, _, _, _, _, _, instanceMapId, _ = GetInstanceInfo()
            if (instanceMapId == 531 and (UnitIsGroupLeader("player") or UnitIsGroupAssistant("player"))) then
                C_Timer.After(3, checkAddons)
            end
        end
        if prefix == "SWCthunPlanner" then
            --DEFAULT_CHAT_FRAME:AddMessage(sender .." => "..msg, 1.0, 1.0, 0)
            if string.find(msg, "SHARE") then
                if (msg == "SHAREv2") then
                    --DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Old version (v2) share, adapting and accepting share..", 1.0, 1.0, 0)
                    melee_sortorder = {"1","5","3","2","4"}
                    caster_sortorder = {"3","4","5","2","1"}
                    healer_sortorder = {"2","3","4","5","1"}
                    local text = ""
                    for index, value in ipairs(melee_sortorder) do
                        text = text .. value .. " "
                    end
                    SWCthunOptions.raidoverrides.sortorder.melee:SetText(text);
                    local text = ""
                    for index, value in ipairs(caster_sortorder) do
                        text = text .. value .. " "
                    end
                    SWCthunOptions.raidoverrides.sortorder.caster:SetText(text);
                    local text = ""
                    for index, value in ipairs(healer_sortorder) do
                        text = text .. value .. " "
                    end
                    SWCthunOptions.raidoverrides.sortorder.healer:SetText(text);
                    frame:Show()
                    SWCthunPlanner_FillGrid()
                end
                if (msg == "SHARE"..version) then
                    frame:Show()
                    SWCthunPlanner_FillGrid()
                end
                if (msg ~= "SHAREv2" and msg ~= "SHARE"..version) then
                    DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Wrong addon version... expect: |cFF00FF00"..version.."|r or v2, got |cFFFF0000".. string.sub(msg, 6, start).."|r", 1.0, 1.0, 0)
                    C_ChatInfo.SendAddonMessage("SWCthunPlanner", "CHECKRES"..version.."1: " .. SWCthunPlanner_PlayerName, "WHISPER", sender)
                end
            end

            if (msg == "CLEAR" and playername ~= string.sub(sender, 0, string.find(msg,"-"))) then
                --DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r clearing", 1.0, 1.0, 0)
                melee = {}
                caster = {}
                healer = {}
                melee_sortorder = {}
                caster_sortorder = {}
                healer_sortorder = {}
                SWCthunOptions.raidoverrides.casterbox.text:SetText("")
                SWCthunOptions.raidoverrides.healerbox.text:SetText("")
                SWCthunOptions.raidoverrides.meleebox.text:SetText("")

            end

            if (startswith(msg,"MELEESORT:") and playername ~= string.sub(sender, 0, string.find(msg,"-"))) then
                local myTable = splitstring(msg,":")
                for i = 2, #myTable do
                    table.insert(melee_sortorder, myTable[i])
                end

                local text = ""
                for index, value in ipairs(melee_sortorder) do
                    text = text .. value .. " "
                end
                SWCthunOptions.raidoverrides.sortorder.melee:SetText(text);
            end

            if (startswith(msg,"CASTERSORT:") and playername ~= string.sub(sender, 0, string.find(msg,"-"))) then
                local myTable = splitstring(msg,":")
                for i = 2, #myTable do
                    table.insert(caster_sortorder, myTable[i])
                end

                local text = ""
                for index, value in ipairs(caster_sortorder) do
                    text = text .. value .. " "
                end
                SWCthunOptions.raidoverrides.sortorder.caster:SetText(text);
            end

            if (startswith(msg,"HEALERSORT:") and playername ~= string.sub(sender, 0, string.find(msg,"-"))) then
                local myTable = splitstring(msg,":")
                for i = 2, #myTable do
                    table.insert(healer_sortorder, myTable[i])
                end

                local text = ""
                for index, value in ipairs(healer_sortorder) do
                    text = text .. value .. " "
                end
                SWCthunOptions.raidoverrides.sortorder.healer:SetText(text);
            end

            if (startswith(msg,"ADDMELEE:") and playername ~= string.sub(sender, 0, string.find(msg,"-"))) then
                
                local myTable = splitstring(msg,":")
                for i = 2, #myTable do
                    table.insert(melee, myTable[i])
                end

                local text = ""
                for index, value in ipairs(melee) do
                    text = text .. value .. "\n"
                end
                SWCthunOptions.raidoverrides.meleebox.text:SetText(text)
            end

            if (startswith(msg,"ADDCAST:") and playername ~= string.sub(sender, 0, string.find(msg,"-"))) then
                local myTable = splitstring(msg,":")
                for i = 2, #myTable do
                    table.insert(caster, myTable[i])
                end

                local text = ""
                for index, value in ipairs(caster) do
                    text = text .. value .. "\n"
                end
                SWCthunOptions.raidoverrides.casterbox.text:SetText(text)

            end

            if (startswith(msg,"ADDHEAL:") and playername ~= string.sub(sender, 0, string.find(msg,"-"))) then
                local myTable = splitstring(msg,":")
                for i = 2, #myTable do
                    table.insert(healer, myTable[i])
                end

                local text = ""
                for index, value in ipairs(healer) do
                    text = text .. value .. "\n"
                end
                SWCthunOptions.raidoverrides.healerbox.text:SetText(text)
            end

            if msg == "CHECK" then
                C_ChatInfo.SendAddonMessage("SWCthunPlanner", "CHECKRES"..version..": " .. SWCthunPlanner_PlayerName, "WHISPER", sender)
            end

            if string.find(msg, "CHECKRES"..version..": ") then
                local _, start = string.find(msg, "CHECKRES"..version..": ")
                local name = string.sub(msg, start + 1, string.len(msg))

                for i, v in ipairs(checkRoster) do
                    if v == name then
                        table.remove(checkRoster, i)
                        table.insert(checkokRoster,v)
                    end
                end
            elseif (string.find(msg, "CHECKRES") and not string.find(msg, "CHECKRES"..version..": ")) then
                local _, start = string.find(msg, ": ")
                local name = string.sub(msg, start + 1, string.len(msg))
                DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r "..name.." has different protocol version |cFFFF0000"..string.sub(msg, 9, start-1).."|r expecting |cFF00FF00"..version.."|r", 1.0, 1.0, 0)
            end

        end
    end
)

local resizeframe
local Width = frame:GetWidth()
local Height = frame:GetHeight()

local function Resizer(frame)
    local s = frame:GetWidth() / Width
    local childrens = {frame:GetChildren()}
    for _, child in ipairs(childrens) do
        if child ~= resizeframe then
            child:SetScale(s)
        end
    end
    frame:SetHeight(Height * s)
end

local function debug(s)
    DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r"..s, 1.0, 1.0, 0)
end

local function ResizeFrame(frame)
    resizeframe = CreateFrame("Frame", "CthunResize", frame)
    resizeframe:SetPoint("BottomRight", frame, "BottomRight", -8, 7)
    resizeframe:SetWidth(16)
    resizeframe:SetHeight(16)
    resizeframe:SetFrameLevel(frame:GetFrameLevel() + 7)
    resizeframe:EnableMouse(true)
    local resizetexture = resizeframe:CreateTexture(nil, "Artwork")
    resizetexture:SetPoint("TopLeft", resizeframe, "TopLeft", 0, 0)
    resizetexture:SetWidth(16)
    resizetexture:SetHeight(16)
    resizetexture:SetTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
    frame:SetMaxResize(Width * 1.5, Height * 1.5)
    frame:SetMinResize(Width / 2.5, Height / 2.5)
    frame:SetResizable(true)
    resizeframe:SetScript(
        "OnEnter",
        function(self)
            resizetexture:SetTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
        end
    )
    resizeframe:SetScript(
        "OnLeave",
        function(self)
            resizetexture:SetTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
        end
    )
    resizeframe:SetScript(
        "OnMouseDown",
        function(self, button)
            if button == "RightButton" then
                frame:SetWidth(Width)
                frame:SetHeight(Height)
            else
                resizetexture:SetTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
                frame:StartSizing("Right")
            end
        end
    )
    resizeframe:SetScript(
        "OnMouseUp",
        function(self, button)
            local x, y = GetCursorPosition()
            local fx = self:GetLeft() * self:GetEffectiveScale()
            local fy = self:GetBottom() * self:GetEffectiveScale()
            if x >= fx and x <= (fx + self:GetWidth()) and y >= fy and y <= (fy + self:GetHeight()) then
                resizetexture:SetTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
            else
                resizetexture:SetTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
            end
            frame:StopMovingOrSizing()
        end
    )
    local scrollframe = CreateFrame("ScrollFrame", "CthunScroll", frame)
    scrollframe:SetWidth(Width)
    scrollframe:SetHeight(Height)
    scrollframe:SetPoint("Topleft", frame, "Topleft", 0, 0)
    frame:SetScript(
        "OnSizeChanged",
        function(self)
            Resizer(frame)
        end
    )
end

ResizeFrame(frame)

local SWCthunPlanner_Slider = CreateFrame("Slider", "MySlider1", frame, "OptionsSliderTemplate")
SWCthunPlanner_Slider:SetPoint("BOTTOM", frame, "BOTTOM", 0, 20)
SWCthunPlanner_Slider:SetMinMaxValues(0.05, 1.00)
SWCthunPlanner_Slider:SetValue(1.00)
SWCthunPlanner_Slider:SetValueStep(0.05)
SWCthunPlanner_Slider:SetResizable(true)
getglobal(SWCthunPlanner_Slider:GetName() .. "Low"):SetText("5%")
getglobal(SWCthunPlanner_Slider:GetName() .. "High"):SetText("100%")
getglobal(SWCthunPlanner_Slider:GetName() .. "Text"):SetText("Opacity")
SWCthunPlanner_Slider:SetScript(
    "OnValueChanged",
    function(self)
        local value = SWCthunPlanner_Slider:GetValue()
        frame:SetAlpha(value)
    end
)

local SWCthunPlanner_Header = CreateFrame("Frame", "SWCthunPlanner_Header", frame)
SWCthunPlanner_Header:SetPoint("TOP", frame, "TOP", 0, 12)
SWCthunPlanner_Header:SetWidth(256)
SWCthunPlanner_Header:SetHeight(64)
SWCthunPlanner_Header:SetBackdrop(
    {
        bgFile = "Interface\\DialogFrame\\UI-DialogBox-Header"
    }
)

SWCthunPlanner_Header:SetScript(
    "OnMouseDown",
    function(self, button)
        frame:StartMoving("TOPLEFT")
        frame:SetUserPlaced(true)
    end
)

SWCthunPlanner_Header:SetScript(
    "OnMouseUp",
    function(self, button)
        frame:StopMovingOrSizing()
    end
)

local SWCthunPlanner_Fontstring = SWCthunPlanner_Header:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
SWCthunPlanner_Fontstring:SetPoint("CENTER", SWCthunPlanner_Header, "CENTER", 0, 12)
SWCthunPlanner_Fontstring:SetText("SW C'Thun Planner")

local button = CreateFrame("Button", "SWCthunPlanner_Close", frame)
button:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -5, -5)
button:SetHeight(32)
button:SetWidth(32)
button:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
button:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
button:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
button:SetScript(
    "OnLoad",
    function()
        button:RegisterForClicks("AnyUp")
    end
)
button:SetScript(
    "OnClick",
    function()
        frame:Hide()
    end
)

local num_dots = 0

local function newDot(x, y, name, class)
    num_dots = num_dots + 1

    local dot

    if _G["CthunDot_" .. num_dots] == nil then
        dot = CreateFrame("Button", "CthunDot_" .. num_dots, frame)
        dot:SetResizable(true)
        dot:SetPoint("CENTER", frame, "CENTER", x, y)
        dot:EnableMouse(true)

        local texdot = dot:CreateTexture(nil, "OVERLAY")
        dot.texture = texdot
        texdot:SetAllPoints(dot)

        if (name == "Empty") then
            texdot:SetTexture(nil)
        else
            if (UnitName("player") == name) then
                texdot:SetTexture("Interface\\AddOns\\SWCthunPlanner\\Images\\playerdot_player.tga")
            else
                _, _, classID = UnitClass(name)
                texdot:SetTexture("Interface\\AddOns\\SWCthunPlanner\\Images\\playerdot_" .. classID .. ".tga")
            end
        end

        dot:SetFrameLevel(dot:GetFrameLevel() + 3)
    else
        dot = _G["CthunDot_" .. num_dots]

        if (name == "Empty") then
            dot.texture:SetTexture(nil)
        else
            if (UnitName("player") == name) then
                dot.texture:SetTexture("Interface\\AddOns\\SWCthunPlanner\\Images\\playerdot_player.tga")
            else
                _, _, classID = UnitClass(name)
                dot.texture:SetTexture("Interface\\AddOns\\SWCthunPlanner\\Images\\playerdot_" .. classID .. ".tga")
            end

        end
    end

    if (SWCthunPlanner_PlayerName == name) then
        dot:SetWidth(32)
        dot:SetHeight(32)
    else
        dot:SetWidth(20)
        dot:SetHeight(20)
    end

    dot:RegisterEvent("GROUP_ROSTER_UPDATE")
    dot:SetScript(
        "OnEvent",
        function()
            SWCthunPlanner_WipeReserves(true)
        end
    )

    dot:SetScript(
        "OnEnter",
        function()
            GameTooltip:SetOwner(dot, "ANCHOR_RIGHT")
            GameTooltip:SetText(name)
            GameTooltip:Show()
        end
    )
    dot:SetScript(
        "OnLeave",
        function()
            GameTooltip:Hide()
        end
    )

    dot:SetScale(frame:GetEffectiveScale())
    Resizer(frame)
    return dot
end

local dotRes = {
    {{"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}}, -- group 1
    {{"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}}, -- group 2
    {{"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}}, --    |
    {{"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}}, --    |
    {{"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}}, --    |
    {{"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}}, --    |
    {{"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}}, --    |
    {{"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}, {"Empty", "Empty"}}
} -- group 8

local meleeMarks = {"", "", "", "", "", "", "", ""}

function isin(tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

function splitstring(source, sep)
    local result, i = {}, 1
    while true do
        local a, b = source:find(sep)
        if not a then break end
        local candidat = source:sub(1, a - 1)
        if candidat ~= "" then 
            result[i] = candidat
        end i=i+1
        source = source:sub(b + 1)
    end
    if source ~= "" then 
        result[i] = source
    end
    return result
end

function trim(s)
    return (s:gsub("^%s*(.-)%s*$", "%1"))
end

function startswith(String,Start)
    return string.sub(String,1,string.len(Start)) == Start
end

-- WOW Class IDs
--1 	Warrior
--2 	Paladin
--3 	Hunter
--4 	Rogue
--5 	Priest
--6 	Death Knight
--7 	Shaman
--8 	Mage
--9	    Warlock
--10	Monk
--11	Druid
--12	Demon Hunter


local function getRaidInfo()
    if (#melee_sortorder + #caster_sortorder + #healer_sortorder < 15) then
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000SWCThunPlanner FATAL ERROR! Sortorder not complete...|r", 1.0, 1.0, 0)
        return
    end
    meleeMarks = {"", "", "", "", "", "", "", ""}
    for i = 1, 40 do
        local name, _, subgroup, _, class, _, _, _, _, role = GetRaidRosterInfo(i)
        local classID=0
        if name then
            _, _, classID = UnitClass(name)
        end
        --DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000 "..tostring(name).." ["..tostring((isin(melee,name) or (not isin(caster,name) and not isin(healer,name) and (class == "Rogue" or class == "Warrior" or class == "Krieger" or class == "Schurke" or (class == "Druid" and role == "maintank") or (class == "Druide" and role == "Haupttank"))))).."] ("..tostring(isin(melee,name)).." "..tostring(isin(caster,name)).." "..tostring(isin(healer,name))..")!|r", 1.0, 1.0, 0)
        if (isin(melee,name) or (not isin(caster,name) and not isin(healer,name) and (classID == 4 or classID == 1 or (classID == 11 and (role == "maintank" or role == "Haupttank"))))) then
            local placed = false
            for i = 1, #melee_sortorder do
                local spot = tonumber(melee_sortorder[i])
                --DEFAULT_CHAT_FRAME:AddMessage(i.." - "..spot.." - "..name, 1.0, 1.0, 0)
                if (dotRes[subgroup][spot][1] == "Empty" or dotRes[subgroup][spot][1] == name) and not placed then
                    dotRes[subgroup][spot] = {name, class}
                    if (spot == 1) then
                        meleeMarks[subgroup] = name
                    end
                    --DEFAULT_CHAT_FRAME:AddMessage("placed", 1.0, 1.0, 0)
                    placed = true
                end
            end
        elseif (isin(caster,name) or (not isin(melee,name) and not isin(healer,name) and (classID == 8 or classID == 9 or classID == 3))) then
            local placed = false
            for i = 1, #caster_sortorder do
                local spot = tonumber(caster_sortorder[i])
                --DEFAULT_CHAT_FRAME:AddMessage(i.." - "..spot.." - "..name, 1.0, 1.0, 0)
                if (dotRes[subgroup][spot][1] == "Empty" or dotRes[subgroup][spot][1] == name) and not placed then
                    dotRes[subgroup][spot] = {name, class}
                    if (spot == 1) then
                        meleeMarks[subgroup] = name
                    end
                    --DEFAULT_CHAT_FRAME:AddMessage("placed", 1.0, 1.0, 0)
                    placed = true
                end
            end
        elseif (isin(healer,name) or (not isin(melee,name) and not isin(caster,name) and (classID == 2 or classID == 5 or classID == 7 or classID == 11))) then
            local placed = false
            for i = 1, #healer_sortorder do
                local spot = tonumber(healer_sortorder[i])
                --DEFAULT_CHAT_FRAME:AddMessage(i.." - "..spot.." - "..name, 1.0, 1.0, 0)
                if (dotRes[subgroup][spot][1] == "Empty" or dotRes[subgroup][spot][1] == name) and not placed then
                    dotRes[subgroup][spot] = {name, class}
                    if (spot == 1) then
                        meleeMarks[subgroup] = name
                    end
                    --DEFAULT_CHAT_FRAME:AddMessage("placed", 1.0, 1.0, 0)
                    placed = true
                end
            end
        end
    end
end

function SWCthunPlanner_FillGrid()
    SWCthunPlanner_WipeReserves()
    getRaidInfo()
    local count = 0
    for i = 1, 8 do
        for j = 1, 5 do
            count = count + 1
            local x = ((i - 1) * 5) + j
            local dot = newDot(dotPos[x][1], dotPos[x][2], dotRes[i][j][1], dotRes[i][j][2])
        end
    end
end

local function shareGrid()
    melee = SWCthunGlobalMeleeOverrideSave
    caster = SWCthunGlobalCasterOverrideSave
    healer = SWCthunGlobalHealerOverrideSave

    melee_sortorder = SWCthunGlobalMeleeSortorderSave
    caster_sortorder = SWCthunGlobalCasterSortorderSave
    healer_sortorder = SWCthunGlobalHealerSortorderSave

    C_ChatInfo.SendAddonMessage("SWCthunPlanner", "CLEAR", "RAID")
    if #melee_sortorder > 0 then
        local sortstring = "MELEESORT:"
        for i=1,#melee_sortorder do
            sortstring = sortstring..":"..melee_sortorder[i]
        end
        C_ChatInfo.SendAddonMessage("SWCthunPlanner", sortstring, "RAID")
    end

    if #caster_sortorder > 0 then
        local sortstring = "CASTERSORT:"
        for i=1,#caster_sortorder do
            sortstring = sortstring..":"..caster_sortorder[i]
        end
        C_ChatInfo.SendAddonMessage("SWCthunPlanner", sortstring, "RAID")
    end

    if #healer_sortorder > 0 then
        local sortstring = "HEALERSORT:"
        for i=1,#healer_sortorder do
            sortstring = sortstring..":"..healer_sortorder[i]
        end
        C_ChatInfo.SendAddonMessage("SWCthunPlanner", sortstring, "RAID")
    end

    if #melee > 0 then
        local meleestring = "ADDMELEE"
        for i=1,#melee do
            meleestring = meleestring..":"..melee[i]
        end
        if string.len(meleestring) > 255 then
            DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000Too many melee overrides, cancelling share ("..string.len(meleestring).." > 255)!|r", 1.0, 1.0, 0)
            return false
        else
            C_ChatInfo.SendAddonMessage("SWCthunPlanner", meleestring, "RAID")
        end
    end

    if #caster > 0 then
        local caststring = "ADDCAST"
        for i=1,#caster do
            caststring = caststring..":"..caster[i]
        end
        if string.len(caststring) > 255 then
            DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000Too many caster overrides, cancelling share ("..string.len(caststring).." > 255)!|r", 1.0, 1.0, 0)
            return false
        else
            C_ChatInfo.SendAddonMessage("SWCthunPlanner", caststring, "RAID")
        end
    end

    if #healer > 0 then
        local healstring = "ADDHEAL"
        for i=1,#healer do
            healstring = healstring..":"..healer[i]
        end
        if string.len(healstring) > 255 then
            DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000Too many healer overrides, cancelling share ("..string.len(healstring).." > 255)!|r", 1.0, 1.0, 0)
            return false
        else
            C_ChatInfo.SendAddonMessage("SWCthunPlanner", healstring, "RAID")
        end
    end
    C_ChatInfo.SendAddonMessage("SWCthunPlanner", "SHARE" .. version, "RAID")
end

local function getRoster()
    local roster = {}

    for i = 1, 41 do
        --local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
        local name = GetRaidRosterInfo(i)
        if name then
            table.insert(roster, name)
        end
    end

    return roster
end

local function getCheckRoster()
    local roster = {}
    checkofflineRoster = {}
    for i = 1, 41 do
        --local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
        local name,_,_,_,_,_,_,online = GetRaidRosterInfo(i)
        if (name and online) then
            table.insert(roster, name)
        end
        if (name and not online) then
            table.insert(checkofflineRoster, name)
        end
    end

    return roster
end

local function markMelee()
    if firstFill == nil then
        SWCthunPlanner_FillGrid()
        firstFill = true
    end

    for i, v in ipairs(meleeMarks) do
        if v ~= "" and UnitExists(v) then
            SetRaidTarget(v, i)
        end
    end
end

function checkAddons()
    checkRoster = getCheckRoster()
    checkokRoster = {}
    C_ChatInfo.SendAddonMessage("SWCthunPlanner", "CHECK", "RAID")
    DEFAULT_CHAT_FRAME:AddMessage(
        "|cff00d2d6SWCThunPlanner:|r checking if everyone has the addon installed..",
        1.0,
        1.0,
        0
    )
    C_Timer.After(3, SWCthunPlanner_CheckResults)
end

function SWCthunPlanner_CheckResults()
    if (table.getn(checkRoster) > 0 or table.getn(checkofflineRoster) > 0) then
        DEFAULT_CHAT_FRAME:AddMessage("   |cFF00FF00Addon installed:|r " .. table.concat(checkokRoster, ", "), 1.0, 1.0, 0)
        DEFAULT_CHAT_FRAME:AddMessage("   |cFFFF0000Missing Addon:|r " .. table.concat(checkRoster, ", "), 1.0, 1.0, 0)
        DEFAULT_CHAT_FRAME:AddMessage("   |cFFCCCCCCOffline:|r " .. table.concat(checkofflineRoster, ", "), 1.0, 1.0, 0)
    else
        DEFAULT_CHAT_FRAME:AddMessage("   |cFF00FF00All players have SWCThunPlanner installed!|r", 1.0, 1.0, 0)
    end
end

function SWCthunPlanner_WipeReserves(update)
    num_dots = 0
    for i = 1, 8 do
        for j = 1, 5 do
            for k = 1, 2 do
                dotRes[i][j][k] = "Empty"
            end
        end
    end

    if update then
        SWCthunPlanner_FillGrid()
    end
end

SLASH_SWCthunPlanner1 = "/cthun"

local function HandleSlashCommands(str)
    if (str == "help") then
        DEFAULT_CHAT_FRAME:AddMessage("CthunPlanner modified by Flussleiche@Razorfen", 1.0, 1.0, 0)
        DEFAULT_CHAT_FRAME:AddMessage("Based on PHGP CthunPlanner by Buloka/PHGP", 1.0, 1.0, 0)
        DEFAULT_CHAT_FRAME:AddMessage("Commands:", 1.0, 1.0, 0)
        DEFAULT_CHAT_FRAME:AddMessage("   /cthun |cff00d2d6help |r-- show this help menu", 1.0, 1.0, 0)
        DEFAULT_CHAT_FRAME:AddMessage("   /cthun |cff00d2d6mark |r-- marks the main melee for each group", 1.0, 1.0, 0)
        DEFAULT_CHAT_FRAME:AddMessage("   /cthun |cff00d2d6share |r-- displays the planner to your raid", 1.0, 1.0, 0)
        DEFAULT_CHAT_FRAME:AddMessage(
            "   /cthun |cff00d2d6check |r-- check if all raiders have the addon installed",
            1.0,
            1.0,
            0
        )
    elseif ((str == "" or str == nil) and not (UnitIsGroupLeader("player") or UnitIsGroupAssistant("player"))) then
        if (#melee_sortorder + #caster_sortorder + #healer_sortorder < 15) then
            DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000SWCThunPlanner Error! No overrides received yet!|r", 1.0, 1.0, 0)
            return
        end
        frame:Show()
        SWCthunPlanner_FillGrid()
    elseif ((str == "" or str == "fill" or str == nil) and (UnitIsGroupLeader("player") or UnitIsGroupAssistant("player"))) then
        melee = SWCthunGlobalMeleeOverrideSave
        caster = SWCthunGlobalCasterOverrideSave
        healer = SWCthunGlobalHealerOverrideSave
        melee_sortorder = SWCthunGlobalMeleeSortorderSave
        caster_sortorder = SWCthunGlobalCasterSortorderSave
        healer_sortorder = SWCthunGlobalHealerSortorderSave
        DEFAULT_CHAT_FRAME:AddMessage("|cff00d2d6SWCThunPlanner:|r Filling grid using local overrides (local preview for Raidleaders)|r", 1.0, 1.0, 0)
        frame:Show()
        SWCthunPlanner_FillGrid()
    elseif (str == "share") then
        if IsInGroup() then
            if (UnitIsGroupLeader("player") or UnitIsGroupAssistant("player")) then
                if shareGrid() then
                    frame:Show()
                    SWCthunPlanner_FillGrid()
                else
                    frame:Hide()
                end
            else
                DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000SWCthunPlanner:|r Only the group leader or assistant can share.", 1.0, 1.0, 0)
            end
        else
            DEFAULT_CHAT_FRAME:AddMessage(
                "|cFFFF0000SWCthunPlanner:|r You need to be in a raid to use this command.",
                1.0,
                1.0,
                0
            )
        end
    elseif (str == "mark" or str == "marks") then
        markMelee()
    elseif (str == "option" or str == "options" or str == "config") then
        InterfaceOptionsFrame_OpenToCategory(SWCthunOptions.panel.name)
        InterfaceOptionsFrame_OpenToCategory(SWCthunOptions.panel.name) 
    elseif (str == "check") then
        if (UnitIsGroupLeader("player") or UnitIsGroupAssistant("player")) then
            checkAddons()
        else
            DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000SWCthunPlanner:|r Only the group leader or assistant can check versions.", 1.0, 1.0, 0)
        end
    else
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000SWCthunPlanner:|r Command not found, use /cthun help", 1.0, 1.0, 0)
    end
end

SlashCmdList.SWCthunPlanner = HandleSlashCommands
